﻿Imports Wisej.Web
Imports System.ComponentModel

' === UserControl per la toolbar ===
Public Class ToolbarCellControl
    Inherits UserControl

    Public Event EditClicked(rowIndex As Integer)
    Public Event DeleteClicked(rowIndex As Integer)

    Public Sub New()
        Dock = DockStyle.Fill
        Dim fl As New FlowLayoutPanel With {.Dock = DockStyle.Fill, .Padding = New Padding(0)}

        Dim btnEdit As New Button With {.Text = "✏️", .AutoSize = True, .Margin = New Padding(2)}
        Dim btnDel As New Button With {.Text = "🗑", .AutoSize = True, .Margin = New Padding(2)}

        AddHandler btnEdit.Click, Sub() RaiseEvent EditClicked(CInt(Me.Tag))
        AddHandler btnDel.Click, Sub() RaiseEvent DeleteClicked(CInt(Me.Tag))

        fl.Controls.AddRange({btnEdit, btnDel})
        Controls.Add(fl)

    End Sub
End Class

' === Cella custom con controllo ===
Public Class DataGridViewToolbarCell
    Inherits DataGridViewCell

    Public Sub New()
        Me.Control = New ToolbarCellControl() With {.Dock = DockStyle.Fill}
    End Sub

    Public Overrides Function Clone() As DataGridViewCell
        Dim cell = DirectCast(MyBase.Clone(), DataGridViewCell)
        cell.Control = New ToolbarCellControl() With {.Dock = DockStyle.Fill}
        Return cell
    End Function
End Class

' === Colonna custom ===
Public Class DataGridViewToolbarColumn
    Inherits DataGridViewColumn

    Public Sub New()
        MyBase.New(New DataGridViewToolbarCell())
        Me.HeaderText = "Azioni"
        Me.Width = 90
    End Sub
End Class

' === Classe di esempio ===
Public Class Item
    Public Property Name As String
End Class