﻿Imports System
Imports System.ComponentModel
Imports Wisej.Web

Public Class Window1

    Private bindingList As BindingList(Of Item)
    Private Sub Window1_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        ' Dati
        bindingList = New BindingList(Of Item)()
        For i As Integer = 1 To 5
            bindingList.Add(New Item With {.Name = $"Elemento {i}"})
        Next

        ' Binding
        DataGridView1.DataSource = bindingList

        ' Colonna dati
        Dim colText As New DataGridViewTextBoxColumn With {
            .HeaderText = "Nome",
            .DataPropertyName = "Name",
            .Name = "Name"
        }
        DataGridView1.Columns.Add(colText)

        ' Colonna toolbar custom
        Dim colToolbar As New DataGridViewToolbarColumn With {.Name = "Azioni"}
        DataGridView1.Columns.Add(colToolbar)

        ' Dopo binding, collega eventi ai controlli
        AddHandler DataGridView1.DataBindingComplete, AddressOf BindControlEvents

    End Sub

    Private Sub BindControlEvents(sender As Object, e As DataGridViewBindingCompleteEventArgs)
        For Each row As DataGridViewRow In DataGridView1.Rows
            If Not row.IsNewRow Then
                ' Crea un nuovo controllo per ogni riga
                Dim ctrl As New ToolbarCellControl()
                ctrl.Tag = row.Index

                AddHandler ctrl.EditClicked, AddressOf OnEditClicked
                AddHandler ctrl.DeleteClicked, AddressOf OnDeleteClicked

                row.Cells("Azioni").Control = ctrl
            End If
        Next
    End Sub

    Private Sub OnEditClicked(rowIndex As Integer)
        AlertBox.Show($"Modifica: {bindingList(rowIndex).Name}", MessageBoxIcon.Information)
    End Sub

    Private Sub OnDeleteClicked(rowIndex As Integer)
        If MessageBox.Show($"Eliminare {bindingList(rowIndex).Name}?", "Conferma", MessageBoxButtons.YesNo) = DialogResult.Yes Then
            bindingList.RemoveAt(rowIndex)
        End If
    End Sub

End Class
